<?php
/*
* all functions for the linklist
* with own database connection management
* edited by:
* last edit:
* creation date: 2005/10/22
* author: david toniolo <d.toniolo@mtwebdesign.de>
*/


/**
* all functions for the linklist
* @author David Toniolo <d.toniolo@mtwebdesign.de>
*/
class Linklist
{
  var $db_connect;
  var $db_server;
  var $db_name;
  var $db_user;
  var $db_passw;
  var $table  = array('cat' => '`ll_category`',
                      'links' => '`ll_links`',
                      'clicks' => '`ll_clicks`');
  var $ext    = array('cfg' => '.cfg' ,
                      'txt' => '.txt');
  var $pattern_domain = '^((http://)([A-Za-z0-9-]*\.?[a-zA-Z0-9-]{3,}\.[a-zA-Z]{2,6}(/?.*)))$';                     
  
  // heads
  var $h_install                = 'Installation: Linkliste';
  var $h_linklist_stats         = 'Linkliste Statistik';
  var $h_linklist_editfiles     = 'Linkliste Konfigurationsdaten';
  var $h_linklist_proposal      = 'Empfehlungen von Besuchern';
  var $h_linklist_db_server     = 'Datenbank Server';
  var $h_linklist_db_name       = 'Datenbankname';
  var $h_linklist_db_user       = 'Datenbankbenutzer';
  var $h_linklist_db_passw      = 'Benutzerpasswort';  
  var $h_linklist_admin_passw   = 'Admin Passwort';
  var $h_categories             = 'Kategorien';
  
  // messages & errors
  var $install_dbdata_error = 'Datanbankname fehlt oder die Passwrter stimmen nicht berein.';
  var $error_db_connection  = 'Die Konfigurationsdateien fr die DB Verbindung konnten nicht gelesen werden.';
  
  // paths
  var $path_data_files = './../../admin/linklist/';
  var $path_data_files_0 = './admin/linklist/';
  var $path_data_files_1 = './../admin/linklist/';
  var $path_admin_control_panel = './../../admin/index.php';
  var $path_set_new = './set_new.php';
  var $path_set_new_0 = './../admin/linklist/set_new.php';
  var $path_pid_file = './../../admin/';


  /**
  * constructor PHP4
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function Linklist()
  {
    $this->__construct();
  } // end func
  
  /**
  * constructor
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function __construct()
  {
    $this->set_data();
    $this->db_connect();
    register_shutdown_function(array(&$this, '__destruct'));  
  } // end func

  /**
  * destructor
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function __destruct()
  {
    $this->db_disconnect();
  } // end func  
  

  /**
  * installation
  * this function should be private.
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return boolean
  */
  function install()
  {
    $return         = TRUE;
    $db_server      = trim($_POST['db_server']);
    $db_name        = trim($_POST['db_name']);  
    $db_user        = trim($_POST['db_user']);
    $db_passw       = trim($_POST['db_passw']);  
    
    $pid_file       = $this->path_pid_file . '_pid_'; // same PW as db_passw
    
    $data = array('db_server' => $db_server ,
                  'db_name' => $db_name ,
                  'db_user' => $db_user ,
                  'db_passw' => $db_passw);
    
    
    $fhandle_pid = fopen($pid_file, 'w');
    fwrite($fhandle_pid, md5($db_passw));
    if(fclose($fhandle_pid))
    {
      chmod($pid_file, 0640);
    }
    else
    {
      $return = FALSE;
    }
    
    
    foreach($data as $key => $value)
    {
      $file = $this->path_data_files . $key . $this->ext['cfg'];
      
      $fhandle = fopen($file, 'w');
      fwrite($fhandle, $value);
      if(fclose($fhandle))
      {
        chmod($file, 0640);
      }
      else
      {
        $return = FALSE;
      }
    }
    
    $this->set_data();
    $this->db_connect();    
    
    
    /*
    * MySQL tables
    */    
    $sql_ll_category = "CREATE TABLE IF NOT EXISTS `ll_category` (
    `id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
    `name` VARCHAR( 50 ) NOT NULL ,
    `hidden` ENUM( 'no', 'yes' ) NOT NULL ,
    PRIMARY KEY ( `id` ) ,
    UNIQUE ( `name` )
    ) TYPE = MYISAM COMMENT = 'Linkliste Tabelle'";
    
    $sql_ll_links = "CREATE TABLE IF NOT EXISTS `ll_links` (
    `id` BIGINT UNSIGNED NOT NULL AUTO_INCREMENT ,
    `cat_id` BIGINT NOT NULL ,
    `name` VARCHAR( 50 ) NOT NULL ,
    `url` VARCHAR( 255 ) NOT NULL ,
    `description` VARCHAR( 255 ) ,
    `date` VARCHAR( 15 ) NOT NULL ,
    `hidden` ENUM( 'no', 'yes' ) NOT NULL ,
    `proposal` ENUM( 'no', 'yes' ) NOT NULL ,
    PRIMARY KEY ( `id` ) ,
    INDEX ( `cat_id` ) ,
    FULLTEXT ( `description` )
    ) TYPE = MYISAM COMMENT = 'Linkliste Tabelle'";
    
    $sql_ll_clicks = "CREATE TABLE IF NOT EXISTS `ll_clicks` (
    `link_id` BIGINT NOT NULL ,
    `cat_id` BIGINT NOT NULL ,
    `clicks` BIGINT NOT NULL ,
    `last_upd` TIMESTAMP( 14 ) DEFAULT NULL ,
    INDEX ( `link_id` , `cat_id` )
    ) TYPE = MYISAM COMMENT = 'Linkliste Tabelle'";
    
    // create tables if not exist
    mysql_query($sql_ll_category, $this->db_connect);
    mysql_query($sql_ll_links, $this->db_connect);
    mysql_query($sql_ll_clicks, $this->db_connect);
    
    
    return $return;
  } // end func
  
  
  /**
  *
  * this function should be protected.
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function db_connect()
  {
    $this->db_connect = @mysql_connect($this->db_server, $this->db_user, $this->db_passw);
    @mysql_select_db($this->db_name, $this->db_connect);  
  } // end func 
  
  
  /**
  *
  * this function should be protected.
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function db_disconnect()
  {
    @mysql_close($this->db_connect);
  } // end func    


  /**
  * this function makes a string colored
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param string $text_
  * @param string $color_
  * return void
  */
  function html_color($text_, $color_)
  {
    echo '<span style="color: '. $color_ .';">'. $text_ . '</span>';
  } // end func  
  
  
  /**
  * this function makes a html topic
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param string $text_
  * @param int $int_
  * return void
  */
  function html_topic($text_, $int_)
  {
    echo '<h' . $int_ . '>'. $text_ . '</h' . $int_ . '>';
  } // end func


  /**
  * this function makes a html formular
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param string $text_
  * @param string $name_ name of file to edit
  * @param int $int_  
  * return void
  */
  function html_formular($text_, $name_, $int_ = 0)
  { 
    //$ext      = array('cfg' => '.cfg');
    $content  = $text_;
    $int      = $int_;
    $name     = $name_;
    
    switch($int)
    {
      case 1:
        $type = '<textarea name="content" rows="5" cols="60" style="white-space: pre;">'. $content .'</textarea>';
        $field = 'textarea'; 
      break;
      default:
        $field = 'text'; 
        $type = '<input type="text" name="content" value="'. $content .'" maxlength="150" size="60" />';
    }
    
    switch($name)
    {
      case 'logfile':
        $redirect = './index_logfile.php';
        $file_name = './logfile/logfile_errors.txt';
      break;
      case 'db_passw':
        $redirect = './index_editfiles.php';
        $file_name = './'. $name . $this->ext['cfg'];
        $type = '<input type="password" name="content" value="'. $content .'" maxlength="25" size="60" />';
      break;
      case 'admin_passw':
        $redirect = './index_editfiles.php';
        $file_name = './../_pid_';
        $type = '<input type="password" name="content" value="'. $content .'" maxlength="25" size="60" />';
      break;            
      // cfg files
      default:
        $redirect = './index_editfiles.php';
        $file_name = './'. $name . $this->ext['cfg'];
    }    
  
    echo '
      <form action="./edit_files.php" method="post" name="html_formular_func">
      '. $type .'
      <br />
      <input type="submit" value="ndern" name="submit_html_formular_func" size="20" />
      
      <input type="hidden" value="'. $field .'" name="field" size="20" />
      <input type="hidden" value="'. $redirect .'" name="redirect" size="20" />
      <input type="hidden" value="'. $file_name .'" name="file_name" size="20" />
      </form>
    ';
  } // end func
  

  /**
  * this function makes a html header
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function html_header()
  { 
    echo '
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <html lang="de">
      <head>
        <link rel="shortcut icon" href="./../icon.ico" />
        <link type="text/css" rel="stylesheet" href="./linklist.css" />       
      </head>
      <body>
    ';
  } // end func
  

  /**
  * this function makes a html header
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function html_header_0()
  { 
    echo '
    <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <html lang="de">
      <head>
        <link rel="shortcut icon" href="./../admin/icon.ico" />
        <link type="text/css" rel="stylesheet" href="./../admin/linklist/linklist.css" />
      </head>
      <body>
    ';
  } // end func

  
  /**
  * this function makes a html footer
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function html_footer()
  {
    echo '
        <script language="javascript" type="text/javascript" src="./wz_tooltip.js"></script>
      </body>
    </html>
    '; 
  } // end func
  

  /**
  * this function makes a html footer
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function html_footer_0()
  {
    echo '
        <script language="javascript" type="text/javascript" src="./../admin/linklist/wz_tooltip.js"></script>
      </body>
    </html>
    '; 
  } // end func     


  /**
  * this function sets db connection data
  * this function should be protected.
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function set_data()
  {
    $data = array('db_server' ,
                  'db_name' ,
                  'db_user' ,
                  'db_passw');  

    if(is_readable($file = $this->path_data_files . $data[0] . $this->ext['cfg']))
    {                
      foreach($data as $k)
      {
        $file = $this->path_data_files . $k . $this->ext['cfg'];
        $content = file_get_contents($file);
        
        $this->$k = $content;
      }                          
    }
    elseif(is_readable($file = $this->path_data_files_0 . $data[0] . $this->ext['cfg']))
    {
      foreach($data as $k)
      {
        $file = $this->path_data_files_0 . $k . $this->ext['cfg'];
        $content = file_get_contents($file);
        
        $this->$k = $content;
      }
    }
    elseif(is_readable($file = $this->path_data_files_1 . $data[0] . $this->ext['cfg']))
    {
      foreach($data as $k)
      {
        $file = $this->path_data_files_1 . $k . $this->ext['cfg'];
        $content = file_get_contents($file);
        
        $this->$k = $content;
      }
    }
    else
    {
      if(file_exists($data[0] . $this->ext['cfg']))
      {
        die($this->error_db_connection);
      }
    }
  } // end func
  

  /**
  * this function writes a link into database
  * this function should be protected.
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return boolean
  */
  function set_link()
  {
    $name         = mysql_real_escape_string(trim($_POST['new_link_name']));
    $cat_id       = $_POST['cat'];
    $url          = mysql_real_escape_string(trim($_POST['url']));
    $description  = mysql_real_escape_string(trim($_POST['description']));
    $hidden       = $_POST['hidden'];
    $proposal     = $_POST['proposal']; // yes or no
    $date         = time();
    $return       = FALSE;
    
    
    $hidden = ($hidden === 'on') ? $hidden = 'yes' : $hidden = 'no';
        
    if($this->is_url($url))
    {
      $sql = "INSERT INTO {$this->table['links']} (
          `cat_id` ,
          `name` ,
          `url` ,
          `description` ,
          `date` ,
          `hidden` ,
          `proposal`) 
          VALUES (
          '$cat_id' ,
          '$name' ,
          '$url' ,
          '$description' ,
          '$date' ,
          '$hidden' ,
          '$proposal')";
      if(mysql_query($sql, $this->db_connect))
      {
        $return = TRUE;
      }
    }

    
    return $return;
  } // end func 
  
  
  /**
  *
  * this function should be protected.
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return boolean
  */
  function set_category()
  {
    $new_cat_name = mysql_real_escape_string(trim($_POST['new_cat_name']));
    $hidden       = $_POST['hidden'];
    $return       = FALSE;
    
    
    $hidden = ($hidden === 'on') ? $hidden = 'yes' : $hidden = 'no';
    
    $sql = "INSERT INTO {$this->table['cat']} (
        `name` ,
        `hidden`) 
        VALUES (
        '$new_cat_name',
        '$hidden')"; 
  
    if(mysql_query($sql, $this->db_connect))
    {
      $return = TRUE;
    }
    
    
    return $return;
  } // end func
  
  
  /**
  * this function counts every click
  * this function should be protected.
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $id_
  * @param int $cat_id_
  * return boolean
  */
  function count_click($id_, $cat_id_)
  {
    $return = FALSE;
  
    $sql = "SELECT HIGH_PRIORITY `link_id`, `cat_id`, `clicks` 
            FROM {$this->table['clicks']}
            WHERE `link_id` = $id_";
    $fetch = mysql_fetch_array(mysql_query($sql, $this->db_connect));
    $clicks = (int)$fetch['clicks'];
    
    if($clicks < 1)
    {
      $clicks = 1;
      $sql = "INSERT INTO {$this->table['clicks']} (
              `link_id` ,
              `cat_id` ,
              `clicks` ,
              `last_upd`) 
              VALUES (
              '$id_' ,
              '$cat_id_' ,
              '$clicks' ,
              UNIX_TIMESTAMP())";        
    }
    else
    {
      $clicks = $clicks + 1;
      $sql = "UPDATE {$this->table['clicks']}
              SET `clicks` = $clicks 
              WHERE `link_id` = $id_";
    }

    if(mysql_query($sql, $this->db_connect))
    {
      $return = TRUE;
    }
    

    return $return;
  } // end func
  
  
  /**
  * this function prints editable data on screen
  * this function should be protected.
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $link_id_ link to edit
  * return void
  */
  function cat_editable()
  {
    $cat_id  = $_POST['cat'];
    $order   = ($_POST['order'] === 'clicks') ? 't2.clicks' : '`'.$_POST['order'].'`';
    $sort    = $_POST['sort'];
    $arr_id  = $_POST['link_id']; 
    $border  = 'border00';
    $center  = 'center_ll';
    $color0  = 'color0';
    $color1  = 'color1';
    $color2  = 'color2';
    $mark_all = './mark_all.gif';
    $size_mark_all = getimagesize($mark_all);    
    
    if($_POST['order'] === 'clicks')
    {
      $sql = "SELECT t1.id, t1.cat_id, t1.name, t1.url, t1.description, t1.date, t1.hidden, t1.proposal,
                     t2.link_id, t2.clicks 
              FROM {$this->table['links']} t1, {$this->table['clicks']} t2
              WHERE t1.cat_id = $cat_id
                AND t2.link_id = t1.id
                AND t1.proposal = 'no'
              ORDER BY $order $sort";
    }
    else
    {
      $sql = "SELECT t1.id, t1.cat_id, t1.name, t1.url, t1.description, t1.date, t1.hidden, t1.proposal
              FROM {$this->table['links']} t1
              WHERE t1.cat_id = $cat_id
                AND t1.proposal = 'no'
              ORDER BY $order $sort";          
    }
    $query = mysql_query($sql, $this->db_connect);
    $count_links = mysql_num_rows($query);
    
    echo '
    <table class="linklist">
      <tr>
        <td colspan="7" style="text-align: right;">
          <a href="javascript:void(0)" onClick="CheckAll();">
            <img src="./'. $mark_all .'" width="'. $size_mark_all[0] .'" height="'. $size_mark_all[1] .'" border="0" title="umkehren" alt="Markierungen der Auswahlboxen umkehren" />
          </a>
        </td>
      </tr>     
      <tr>
        <td colspan="7" class="'. $border .' '. $center .' '. $color0 .'">'. $count_links .' von '. $this->count_all() .'</td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
      </tr>      
      <tr>
        <td width="170" class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td width="90" class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td width="45" class="'. $border .' '. $center .' '. $color0 .'">Klicks</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Seit</td>
        <td width="80" class="'. $border .' '. $center .' '. $color0 .'">Status</td>
        <td width="30" class="'. $border .' '. $center .' '. $color0 .'">
          <input type="image" title="bearbeiten" alt="bearbeiten" src="./edit.gif" name="submit_make_editable" value="'. $id .'" />
        </td>
        <td width="30" class="'. $border .' '. $center .' '. $color0 .'">
          <input type="image" title="speichern" alt="speichern" src="./save.gif" name="submit_store_link" value="'. $id .'" />
        </td>
      </tr>
    ';    
    
    $website = getimagesize('./website.gif'); // for image size of all status images
    $greenled = getimagesize('./greenled.gif');
    $redled = getimagesize('./redled.gif');
    $info = getimagesize('./info.gif');
    while($fetch = mysql_fetch_array($query))
    {
      $id           = $fetch['id'];
      $cat_id       = $fetch['cat_id'];
      $name         = $fetch['name'];
      $url          = $fetch['url'];
      $description  = $fetch['description'];
      $date         = date('d.m.y', $fetch['date']);
      $hidden       = $fetch['hidden'];

      $clicks = $this->get_clicks($id);
      $website_img = $this->select_website_img($clicks);
      
      $css = ($css === $color1) ? $color2 : $color1;
      
      if(!empty($arr_id))
      {
        $edit = in_array($id, $arr_id);
      }
      
      if($edit)
      {
        $selected = ($hidden === 'yes') ? NULL : 'selected="selected"';
      
        echo '
        <tr>
          <td><input type="text" name="new_link_name[]" value="'. $name .'" maxlength="50" size="22" /></td>
          <td width="90">
            <input type="text" name="url[]" value="'. $url .'" maxlength="250" size="32" />
            
            <input type="text" name="description[]" value="'. $description .'" maxlength="250" size="32" />
          </td>
          <td class="'. $center .'">'. $clicks .'</td>
          <td>'. $date .'</td>
          <td><select name="hidden[]" size="1">
              <option value="yes" '. $selected .'>versteckt</option>
              <option value="no" '. $selected .'>sichtbar</option>
              <option value="delete">lschen</option>
            </select></td>
          <td>&nbsp;</td>
          <td class="'. $border .' '. $center .' '. $css .'"><input type="checkbox" value="'. $id .'" name="link_id[]" checked="checked" /></td>
        </tr>
        '; 
      }
      else
      {
        $hidden = ($hidden === 'no') ? '<img src="./greenled.gif" width="'. $greenled[0] .'" height="'. $greenled[1] .'" title="sichtbar" alt="sichtbar" />' : '<img src="./redled.gif" width="'. $redled[0] .'" height="'. $redled[1] .'" title="versteckt" alt="versteckt" />';
        
        if(strlen($name) > 20)
        {
          $name = substr($name, 0, 20);
          $name .= '...';
        }        

        echo '
        <tr>
          <td width="170" class="'. $border .' '. $css .'">
            <img onmouseover="return escape(\''. htmlentities($description) .'\')" src="./info.gif" border="0" width="'. $info[0] .'" height="'. $info[1] .'" title="info" alt="info" /> '. $name .'
          </td>
          <td class="'. $border .' '. $css .'"><a href="'. $url .'" target="_blank"><img src="./'. $website_img .'" border="0" width="'. $website[0] .'" height="'. $website[1] .'" title="'. $url .'" alt="website" /></a></td>
          <td class="'. $border .' '. $center .' '. $css .'">'. $clicks .'</td>
          <td class="'. $border .' '. $center .' '. $css .'">'. $date .'</td>
          <td class="'. $border .' '. $center .' '. $css .'">'. $hidden .'</td>
          <td class="'. $border .' '. $center .' '. $css .'"><input type="checkbox" value="'. $id .'" name="link_id[]" /></td>
          <td>&nbsp;</td>
        </tr>
        ';   
      } 
    } // end while
        
    echo '
      <tr>
        <td class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Klicks</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Seit</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Status</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">
          <input type="image" title="bearbeiten" alt="bearbeiten" src="./edit.gif" name="submit_make_editable" value="'. $id .'" />
        </td>
        <td class="'. $border .' '. $center .' '. $color0 .'">
          <input type="image" title="speichern" alt="speichern" src="./save.gif" name="submit_store_link" value="'. $id .'" />
        </td>     
      </tr>    
    </table>';
  } // end func
  
  
  /**
  * this function gets name of a category
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $id_
  * return string
  */
  function get_cat_name($id_)
  {
    $sql = "SELECT `id`, `name`
            FROM {$this->table['cat']}
            WHERE `id` = $id_";
    $query = mysql_query($sql, $this->db_connect);      
    $fetch = mysql_fetch_array($query); 


    return $fetch['name'];  
  } // end func
  
 
  /**
  * this function prints the formular which is above the linklist
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function form_print_list()
  {
    echo '
    <form action="'. $_SERVER['PHP_SELF'] .'" class="form_print_list" method="post" name="print_list">
    ';

      $this->print_categories(3);
      
      //$selected_order = ($_POST['order'] === 'name') ? NULL : 'selected="selected"';
      switch($_POST['order'])
      {
        case 'name':
          $select_name = 'selected="selected"';
        break;
        case 'clicks':
          $select_clicks = 'selected="selected"';
        break;
      }      
      
      $selected_sort  = ($_POST['sort'] === 'ASC') ? NULL : 'selected="selected"';
      
      echo '
        <select name="order" size="1">
          <option value="date">nach Aktualitt</option>
          <option value="name" '. $select_name .'> nach Alphabet</option>
          <option value="clicks" '. $select_clicks .'> nach Klicks</option>
        </select>
        <select name="sort" size="1">
          <option value="ASC">aufsteigend</option>
          <option value="DESC" '. $selected_sort .'>absteigend</option>
        </select>
        <br />
        <br />
        <input type="submit" class="submit" value="Links anzeigen" name="submit_print_list" size="30" />
        <br />
        <br />
      ';
      
    if(isset($_POST['submit_print_list']))
    {
      $this->print_list();
    }
    else
    {
      $this->print_list(1);
    }
    
    echo '    
    </form>
    ';
  } // end func  
  
  /**
  * this function prints the linklist on screen
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $opt_
  * return void
  */
  function print_list($opt_ = 0)
  {
    $cat_id  = $_POST['cat'];
    $order   = ($_POST['order'] === 'clicks') ? 't2.clicks' : '`'.$_POST['order'].'`';
    $sort    = $_POST['sort'];
    $arr_id  = $_POST['link_id'];
    $border  = 'border00';
    $center  = 'center_ll';
    $color0  = 'color0';
    $color1  = 'color1';
    $color2  = 'color2';
    $path_info = './admin/linklist/info.gif';
    
    
    switch($opt_)
    {
      // submit button is not clicked
      case 1:
      $sql0 = "SELECT `id` 
               FROM {$this->table['cat']}
               WHERE `hidden` = 'no'
               ORDER BY id DESC";
      $fetch0 = mysql_fetch_array(mysql_query($sql0, $this->db_connect));

      $cat_id = $fetch0['id'];

      $sql = "SELECT t1.id, t1.cat_id, t1.name, t1.url, t1.description, t1.date, t1.hidden, t1.proposal
                FROM {$this->table['links']} t1
                WHERE t1.cat_id = $cat_id
                  AND t1.hidden = 'no'
                  AND t1.proposal = 'no'
                ORDER BY t1.date DESC";  
      break;
      // submit is clicked
      default:
        if($_POST['order'] === 'clicks')
        {
          $sql = "SELECT t1.id, t1.cat_id, t1.name, t1.url, t1.description, t1.date, t1.hidden, t1.proposal,
                         t2.link_id, t2.clicks 
                  FROM {$this->table['links']} t1, {$this->table['clicks']} t2
                  WHERE t1.cat_id = $cat_id
                    AND t2.link_id = t1.id
                    AND t1.hidden = 'no'
                    AND t1.proposal = 'no'
                  ORDER BY $order $sort";
        }
        else
        {
          $sql = "SELECT t1.id, t1.cat_id, t1.name, t1.url, t1.description, t1.date, t1.hidden, t1.proposal
                  FROM {$this->table['links']} t1
                  WHERE t1.cat_id = $cat_id
                    AND t1.hidden = 'no'
                    AND t1.proposal = 'no'
                  ORDER BY $order $sort";          
        }
    }          
    $query = mysql_query($sql, $this->db_connect);
    $count_links = mysql_num_rows($query); 

    echo '
    <table class="linklist">
      <tr>
        <td colspan="2" class="'. $border .' '. $center .' '. $color0 .'">'. $count_links .' von '. $this->count_all() .'</td>
        <td></td>
      </tr>      
      <tr>
        <td width="170" class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td width="90" class="'. $border .' '. $center .' '. $color0 .'">URL</td>
      </tr>
    ';    
    
    /*
    * Pfad
    */
    
    $legend = getimagesize('./admin/linklist/legend.gif');
    $website = getimagesize('./admin/linklist/website.gif');
    $info = getimagesize($path_info);
    while($fetch = @mysql_fetch_array($query))
    {
      $id           = $fetch['id'];
      $cat_id       = $fetch['cat_id'];
      $name         = $fetch['name'];
      $url          = $fetch['url'];
      $description  = $fetch['description'];
      $hidden       = $fetch['hidden'];

      
      $website_img = $this->select_website_img($this->get_clicks($id));
      
      $css = ($css === $color1) ? $color2 : $color1;
      
      if(!empty($arr_id))
      {
        $edit = in_array($id, $arr_id);
      }
      
      if($edit)
      {
        $selected = ($hidden === 'yes') ? NULL : 'selected="selected"';
      
        echo '
        <tr>
          <td><input type="text" name="new_link_name[]" value="'. $name .'" maxlength="50" size="22" /></td>
          <td><input type="text" name="url[]" value="'. $url .'" maxlength="250" size="32" /></td>
        </tr>
        '; 
      }
      else
      {        
        if(strlen($name) > 20)
        {
          $name = substr($name, 0, 20);
          $name .= '...';
        }        

        
        echo '
        <tr>
          <td width="170" class="'. $border .' '. $css .'">
            <img onmouseover="return escape(\''. htmlentities($description) .'\')" src="'. $path_info .'" border="0" width="'. $info[0] .'" height="'. $info[1] .'" title="info" alt="info" /> '. $name .'
          </td>
          <td class="'. $border .' '. $css .'"><a href="./admin/linklist/clicks.php?id='. $id .'&cat='. $cat_id .'&url='. rawurlencode($url) .'" target="_blank"><img src="./admin/linklist/'. $website_img .'" border="0" width="'. $website[0] .'" height="'. $website[1] .'" title="'. $url .'" alt="website" /></a></td>
        </tr>
        ';   
      } 
    } // end while
        
    echo '
      <tr>
        <td class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">URL</td>    
      </tr>    
    </table>
    <a href="#" onclick="legend()"><img src="./admin/linklist/legend.gif" width="'. $legend[0] .'" height="'. $legend[1] .'" border="0" title="Legende" alt="Hier gehts zur Legende" /></a>
    <a href="#" onclick="proposal()"><img src="./admin/linklist/proposal.gif" width="'. $legend[0] .'" height="'. $legend[1] .'" border="0" title="Website eintragen" alt="Website eintragen" /></a>
    <a href="#" onclick="proposals()"><img src="./admin/linklist/overview.gif" width="'. $legend[0] .'" height="'. $legend[1] .'" border="0" title="Aktuelle Empfehlungen" alt="bersicht aktueller Empfehlungen" /></a>
    ';
      
  } // end func 
  

  /**
  * this function gets amount of clicks per id
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $id_
  * return int
  */
  function get_clicks($id_)
  {
    $sql = "SELECT `link_id`, `cat_id`, `clicks`
            FROM {$this->table['clicks']}
            WHERE `link_id` = $id_";
    $query = mysql_query($sql, $this->db_connect);      
    $fetch = mysql_fetch_array($query); 


    return $fetch['clicks'];
  } // end func 
  
  
  /**
  * this function prints a toplist on screen
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $limit_ [optional]
  * return void
  */
  function top_list($limit_ = 5)
  {
    $bold       = 'bold';
    $border     = 'border00';
    $center     = 'center_ll';
    $color0     = 'color0';
    $color1     = 'color1';
    $color2     = 'color2';
    $path_info  = './../admin/linklist/info.gif';
    $info       = getimagesize($path_info);
    $website    = getimagesize('./../admin/linklist/website.gif');   
  
    $sql = "SELECT t1.link_id, t1.cat_id AS cat_id_clicks, t1.clicks,
                    t2.id, t2.cat_id, t2.name, t2.url, t2.description, t2.date, t2.hidden, t2.proposal,
                    t3.hidden
             FROM {$this->table['clicks']} t1, {$this->table['cat']} t3
             LEFT JOIN {$this->table['links']} t2
             ON t1.link_id = t2.id 
               AND t2.cat_id = t3.id
             WHERE t2.hidden = 'no'
               AND t2.proposal = 'no'
               AND t3.hidden = 'no'
             ORDER BY t1.clicks DESC
             LIMIT $limit_";
    $query = mysql_query($sql, $this->db_connect);
    $count_links = mysql_num_rows($query);
    
    echo '
    <table class="linklist">
      <tr>
        <td colspan="3" class="'. $bold .' '. $border .' '. $center .' '. $color0 .'">Top '. $count_links .'</td>
        <td></td>
      </tr>      
      <tr>
        <td width="170" class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td width="90" class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td width="60" class="'. $border .' '. $center .' '. $color0 .'">Klicks</td>
      </tr>
    ';    
    
    while($fetch = mysql_fetch_array($query))
    {    
      $id          = $fetch['id'];
      $cat_id      = $fetch['cat_id'];
      $name        = $fetch['name'];
      $url         = $fetch['url'];
      $description = $fetch['description'];
      $clicks      = $fetch['clicks'];

      $website_img = $this->select_website_img($clicks);
      
      $css = ($css === $color1) ? $color2 : $color1;    
    
      if(strlen($name) > 20)
      {
        $name = substr($name, 0, 20);
        $name .= '...';
      }        

      echo '
      <tr>
        <td width="170" class="'. $border .' '. $css .'">
          <img onmouseover="return escape(\''. htmlentities($description) .'\')" src="'. $path_info .'" border="0" width="'. $info[0] .'" height="'. $info[1] .'" title="info" alt="info" /> '. $name .'
        </td>
        <td class="'. $border .' '. $css .'"><a href="./../admin/linklist/clicks.php?id='. $id .'&cat='. $cat_id .'&url='. rawurlencode($url) .'" target="_blank"><img src="./../admin/linklist/'. $website_img .'" border="0" width="'. $website[0] .'" height="'. $website[1] .'" title="'. $url .'" alt="website" /></a></td>
        <td class="'. $border .' '. $center .' '. $css .'">'. $clicks .'</td>
      </tr>
      ';       
    }
    
    echo '
      <tr>
        <td class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Klicks</td>   
      </tr>    
    </table>
    ';
  } // end func  
  

  /**
  *
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param string $url_
  * return int 0 || 1
  */
  function is_url($url_)
  {
    $return = eregi($this->pattern_domain, $url_);
  
    return $return;
  } // end func


  /**
  * this function prints the category names on screen
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $mode_ 3 is not admin mode - does not print hidden fields
  * return void
  */
  function print_categories($mode_ = 0)
  {
    $selected_cat = $_POST['cat']; // case 2, 3, 4
    $k = 0;
    
    switch($mode_)
    {
      case 3:
        $sql = "SELECT `id`, `name`, `hidden` 
                FROM {$this->table['cat']}
                WHERE `hidden` = 'no'
                ORDER BY `id` DESC";      
      break;
      default:
        $sql = "SELECT `id`, `name`, `hidden` 
                FROM {$this->table['cat']}
                ORDER BY `id` DESC";
    }
    $query = mysql_query($sql, $this->db_connect);
    $num_rows = mysql_num_rows($query);
    
    
    while($fetch = mysql_fetch_array($query))
    {      
      switch($mode_)
      {
        // shows not hidden categories in DIVs
        case 0:
          switch($fetch['hidden'])
          {
            case 'no':
              echo '<div>'. $fetch['name'] .'</div>';
            break;
            default:
              continue;
          }
        break;
        // shows also hidden categories (acp) in DIVs
        case 1:
          $led = getimagesize('./greenled.gif');
          
          switch($fetch['hidden'])
          {
            case 'no':
              $image = '<img src="./greenled.gif" width="'. $led[0] .'" height="'. $led[1] .'" title="sichtbar" alt="sichtbar" />';
            break;
            default:
              $image = '<img src="./redled.gif" width="'. $led[0] .'" height="'. $led[1] .'" title="versteckt" alt="versteckt" />';
          }        
          echo '<div>'. $image .' '. $fetch['name'] .'</div>';
        break;
        /*
        * edit_cat.frm.php
        * new_link.frm.php
        */
        case 2: case 3:
          $selected = ($selected_cat != $fetch['id']) ? NULL : 'selected="selected"';
                  
          if($k === 0)
          {
            echo '
              <select name="cat" size="1">
            ';
          }
              
          echo '<option value="'. $fetch['id'] .'" '. $selected .'>'. $fetch['name'] .'</option>';
          
          $k++;
              
          if($k === $num_rows)
          {
            echo '            
              </select>              
            ';
          }       
        break;
        case 4:
          $selected = ($selected_cat != $fetch['id']) ? NULL : 'selected="selected"';
                  
          if($k === 0)
          {
            echo '
              <select name="cat[]" size="1">
            ';
          }
              
          echo '<option value="'. $fetch['id'] .'" '. $selected .'>'. $fetch['name'] .'</option>';
          
          $k++;
              
          if($k === $num_rows)
          {
            echo '            
              </select>              
            ';
          }
          break;        
      }
    }
  } // end func


  /**
  * this function prints a file on the screen
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param string $file_ file to print on screen
  * return void
  */
  function print_on_screen($file_)
  {  
    switch($file_)
    {
      case 'logfile':
        $this->html_formular(file_get_contents($this->logfile_errors), $file_, 1);
      break;
      case 'db_server':
        $this->html_topic($this->h_linklist_db_server, 3);
        $this->html_formular(file_get_contents($file_ . $this->ext['cfg']), $file_);
      break;
      case 'db_name':
        $this->html_topic($this->h_linklist_db_name, 3);
        $this->html_formular(file_get_contents($file_ . $this->ext['cfg']), $file_);
      break;
      case 'db_user':
        $this->html_topic($this->h_linklist_db_user, 3);
        $this->html_formular(file_get_contents($file_ . $this->ext['cfg']), $file_);
      break;
      case 'db_passw':
        $this->html_topic($this->h_linklist_db_passw, 3);
        $this->html_formular(file_get_contents($file_ . $this->ext['cfg']), $file_);
      break;
      case 'admin_passw':
        $this->html_topic($this->h_linklist_admin_passw, 3);
        $this->html_formular('', $file_);
      break;                                                                   
    }
  } // end func    
  
  
  /**
  * this function edits the config files or logfile
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function edit_files()
  {  
    $field     = $_POST['field'];
    $file_name = $_POST['file_name'];
    $content   = stripslashes(strip_tags($_POST['content']));
    
    switch($field)
    {
      case 'text':
        $content = trim($content);
      break; 
    }
    
    if($file_name === './../_pid_')
    {
      $content = md5($content);
    }
    
    $fhandle = fopen($file_name, 'w');
    fwrite($fhandle, $content);
    // error handling
    fclose($fhandle);          
  } // end func 
  

  /**
  * this function edits or deletes categories
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function edit_category()
  {  
    $cat_id       = $_POST['cat'];
    $new_cat_name = $_POST['new_cat_name'];
    $hidden       = $_POST['hidden'];
    $delete       = $_POST['delete'];
    
    
    $hidden = ($hidden === 'on') ? $hidden = 'yes' : $hidden = 'no';
    
    if($delete === 'on')
    {
      $sql0 = "DELETE FROM {$this->table['links']} 
               WHERE `cat_id` = $cat_id";
      mysql_query($sql0, $this->db_connect);
      $sql1 = "DELETE FROM {$this->table['clicks']} 
               WHERE `cat_id` = $cat_id";
      mysql_query($sql1, $this->db_connect);       
    
      $sql = "DELETE FROM {$this->table['cat']} 
              WHERE `id` = $cat_id";
    }
    elseif(empty($new_cat_name))
    {
      $sql = "UPDATE {$this->table['cat']} 
              SET `hidden` = '$hidden'
              WHERE `id` = $cat_id";
    }        
    else
    {
      $sql = "UPDATE {$this->table['cat']} 
              SET `name` = '$new_cat_name' ,
                  `hidden` = '$hidden'
              WHERE `id` = $cat_id";    
    }
    
    mysql_query($sql, $this->db_connect);
  } // end func 


  /**
  * this function edits or deletes links
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function edit_link()
  {  
    $arr_id             = $_POST['link_id'];
    $arr_new_link_name  = $_POST['new_link_name'];
    $arr_url            = $_POST['url'];
    $arr_description    = $_POST['description'];
    $arr_hidden         = $_POST['hidden']; // yes or no
    
    
    if(!empty($arr_id))
    {
      $flag = 0;
      foreach($arr_id as $link_id)
      {
        switch($flag)
        {
          case 0:
            $flag         = 1;
            $name         = trim(current($arr_new_link_name));
            $url          = trim(current($arr_url));
            $description  = trim(current($arr_description));
            $hidden       = current($arr_hidden);
          break;
          default:
            $name         = trim(next($arr_new_link_name));
            $url          = trim(next($arr_url));
            $description  = trim(next($arr_description));
            $hidden       = next($arr_hidden);
        }
  
        if($hidden === 'delete')
        {
          $sql = "DELETE FROM {$this->table['links']} 
                  WHERE `id` = $link_id";
        }
        else
        {
          $sql = "UPDATE {$this->table['links']} 
                  SET `name` = '$name' ,
                      `url` = '$url' ,
                      `description` = '$description' ,
                      `hidden` = '$hidden'
                  WHERE `id` = $link_id";    
        }
                
        if($this->is_url($url))
        {
          mysql_query($sql, $this->db_connect);
        }
  
      }
    }
  } // end func 
  
  
  /**
  * this function shows the form to show links (acp only)
  * called in edit_link.frm.php
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */
  function form_show()  
  {    
    echo "
      <script language=\"JavaScript\" type=\"text/javascript\">  
        <!-- 
        function CheckAll() {
          for (var i = 0; i < document.edit_link.elements.length; i++) {
            if(document.edit_link.elements[i].type == 'checkbox'){
              document.edit_link.elements[i].checked = !(document.edit_link.elements[i].checked);
            }
          }
        }
        //-->
      </script> 
    ";    
    
    echo '
    <form action="edit.php" method="post" name="edit_link">    
      <fieldset>
        <legend>Links anzeigen</legend>';

      $this->print_categories(2);
      
      switch($_POST['order'])
      {
        case 'name':
          $select_alphabet = 'selected="selected"';
        break;
        case 'clicks':
          $select_clicks = 'selected="selected"';
        break;
      }
      
      $selected_sort  = ($_POST['sort'] === 'ASC') ? NULL : 'selected="selected"';
      
      echo '
        <select name="order" size="1">
          <option value="date"> nach Aktualitt</option>
          <option value="name" '. $select_alphabet .'> nach Alphabet</option>
          <option value="clicks" '. $select_clicks .'> nach Klicks</option>
        </select>
        <select name="sort" size="1">
          <option value="ASC">aufsteigend</option>
          <option value="DESC" '. $selected_sort .'>absteigend</option>
        </select>
        <input type="submit" class="submit" value="Links anzeigen" name="submit_show_links" size="30" />    
        <br />
        <br />
      ';
      
    if(isset($_POST['submit_show_links'])
        || isset($_POST['submit_make_editable_x']))
    {
      $this->cat_editable();
    }
    echo '
      </fieldset>
      <input type="hidden" name="redirect" value="./index.php" size="20" />
     
    </form>
    ';  
  } // end func
  
  
  /**
  * this function selects a website image.
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return string
  */
  function select_website_img($clicks_)  
  {
    $clicks_ = (int)$clicks_;
  
    if($clicks_ > 4000)
    {
      $return = 'website_foxtrot.gif';
    }
    elseif($clicks_ > 2000)
    {
      $return = 'website_echo.gif';
    }
    elseif($clicks_ > 1000)
    {
      $return = 'website_delta.gif';
    }
    elseif($clicks_ > 500)
    {
      $return = 'website_charlie.gif';
    }
    elseif($clicks_ > 150)
    {
      $return = 'website_bravo.gif';
    }
    elseif($clicks_ > 25)
    {
      $return = 'website_alpha.gif';
    }                  
    else
    {
      $return = 'website.gif';
    }
    
    
    return $return;     
  } // end func
  
  
  /**
  * this function prints the click legend
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return string
  */
  function print_click_legend()  
  {
    $size = getimagesize('./website.gif');
    $clicks = 1;
    $image = './website.gif';
    
    echo '<div class="click_legend">';
    while($clicks !== FALSE)
    {    
      $this->select_website_img($clicks);
      echo '
        <img src="'. $image .'" width="'. $size[0] .'" height="'. $size[1] .'" title="website" alt="Bild ab '. $clicks .' Klicks" /> ab ' . $clicks . ' Klicks
        <br />';

      switch($clicks)
      {
        case 1:
          $clicks = 25;
          $image = './website_alpha.gif';
        break;
        case 25:
          $clicks = 150;
          $image = './website_bravo.gif';
        break;
        case 150:
          $clicks = 500;
          $image = './website_charlie.gif';
        break;
        case 500:
          $clicks = 1000;
          $image = './website_delta.gif';
        break;
        case 1000:
          $clicks = 2000;
          $image = './website_echo.gif';
        break;
        case 2000:
          $clicks = 4000;
          $image = './website_foxtrot.gif';
        break;
        default:
          $clicks = FALSE;
          $image = FALSE;
      }               
    }
    echo '</div>';
  } // end func  
  
  /**
  * this function shows the formular for setting a website
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $mode_ [optional] 1 is proposal formular
  * return void
  */  
  function form_new_website($mode_ = 0)
  {  
    $mode_cat       = ($mode_ === 1) ? 3 : 2;
    $path_action    = ($mode_ === 1) ? $this->path_set_new_0 : $this->path_set_new;
    $path_redirect  = ($mode_ === 1) ? './info.php' : './index.php';
    $submit_text    = ($mode_ === 1) ? 'Link empfehlen' : 'Link hinzufgen';
    $proposal       = ($mode_ === 1) ? 'yes' : 'no';
  
    echo '
      <form action="'. $path_action .'" method="post" name="new_link">
        ';
    if($mode_ !== 1)
    {
      echo '
          <fieldset>
            <legend>Neuen Link hinzufgen</legend>
          ';
    }
       
    echo '
          Bitte mglichst alle Felder ausfllen:
          <table class="proposal bg_0">       
            <tr>
              <td width="100">Kategorie:</td>
              <td>   
        ';
        
        $this->print_categories($mode_cat);
        
        echo '
              </td>
            </tr>   
            <tr>
              <td width="100">Name:</td>
              <td><input type="text" name="new_link_name" maxlength="50" size="20" /></td>
            </tr>
            <tr>  
              <td>URL:</td>
              <td><input type="text" name="url" value="http://" maxlength="250" size="30" /></td>
            </tr>
            <tr>  
              <td>Beschreibung:</td>
              <td><input type="text" name="description" maxlength="230" size="40" /></td>
            </tr>
            ';
            
    if($mode_ !== 1)
    {          
      echo '                   
            <tr>
              <td>Ausblenden:</td>
              <td><input type="checkbox" name="hidden" /></td>
            </tr>
            ';
    }
    
      echo '            
          </table>
          ';
          
    if($mode_ !== 1)
    {          
      echo '          
        </fieldset>
        ';
    }
    
      echo '
        <input type="hidden" name="redirect" value="'. $path_redirect .'" size="20" />
        <input type="hidden" name="proposal" value="'. $proposal .'" size="20" />
        <input type="submit" class="submit" value="'. $submit_text .'" name="submit_new_link" size="30" />
      </form>
      ';
  } // end func
  
  
  /**
  * this function shows the formular for suggest a website
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */  
  function form_proposal()
  {
    $this->form_new_website(1);
  } // end func
  
  
  /**
  * this function prints information after proposal
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */  
  function info()
  {
    $logo = './powered_by_mtd.gif';
    $size = getimagesize($logo);

    echo 'Vielen Dank. Wir werden ihren Link in Krze einstellen.';
    
    echo '
    <div align="center" class="margin0">
    <a href="http://www.mtwebdesign.de" target="_blank">
      <img src="'. $logo .'" width="'. $size[0] .'" height="'. $size[1] .'" border="0" title="www.mtwebdesign.de" alt="Mit Untersttzung von M&T Design" />
    </a>
    </div>';
  } // end func  
  
  
  /**
  * this function prints all proposals
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */  
  function print_proposals()
  {
    $arr_id     = $_POST['link_id']; 
    $border     = 'border00';
    $center     = 'center_ll';
    $color0     = 'color0';
    $color1     = 'color1';
    $color2     = 'color2';  
    $path_info  = './info.gif';  
    $info       = getimagesize($path_info);
    $mark_all = './mark_all.gif';
    $size_mark_all = getimagesize($mark_all);    
    
    
    $sql = "SELECT `id`, `cat_id`, `name`, `url`, `description`, `date`, `hidden`, `proposal`
            FROM {$this->table['links']}
            WHERE `proposal` = 'yes'
            ORDER BY `date` ASC";      

    $query = mysql_query($sql, $this->db_connect);
    $num_rows = mysql_num_rows($query);
    
    echo "
      <script language=\"JavaScript\" type=\"text/javascript\">  
        <!-- 
        function CheckAll() {
          for (var i = 0; i < document.info_linklist.elements.length; i++) {
            if(document.info_linklist.elements[i].type == 'checkbox'){
              document.info_linklist.elements[i].checked = !(document.info_linklist.elements[i].checked);
            }
          }
        }
        //-->
      </script> 
    ";    
    
    echo '
    <form action="'. $_SERVER['PHP_SELF'] .'" method="post" name="info_linklist">

    <table class="linklist">
      <tr>
        <td colspan="7" style="text-align: right;">
          <a href="javascript:void(0)" onClick="CheckAll();">
            <img src="./'. $mark_all .'" width="'. $size_mark_all[0] .'" height="'. $size_mark_all[1] .'" border="0" title="umkehren" alt="Markierungen der Auswahlboxen umkehren" />
          </a>        
        </td>
      </tr>
      <tr>
        <td colspan="7" class="'. $border .' '. $center .' '. $color0 .'">Gesamt: '. $count_links .'</td>
      </tr>      
      <tr>
        <td width="170" class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td width="90" class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Kategorie</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Seit</td>
        <td width="80" class="'. $border .' '. $center .' '. $color0 .'">Status</td>
        <td width="30" class="'. $border .' '. $center .' '. $color0 .'">
          <input type="image" title="bearbeiten" alt="bearbeiten" src="./edit.gif" name="submit_make_editable" value="'. $id .'" />
        </td>
        <td width="30" class="'. $border .' '. $center .' '. $color0 .'">
          <input type="image" title="speichern" alt="speichern" src="./save.gif" name="submit_store_link" value="'. $id .'" />
        </td>
      </tr>
    ';  
    
    while($fetch = mysql_fetch_array($query))
    {
      $id           = $fetch['id'];
      $cat_id       = $fetch['cat_id'];
      $name         = $fetch['name'];
      $url          = $fetch['url'];
      $description  = $fetch['description'];
      $date         = date('d.m.y', $fetch['date']);
      $hidden       = $fetch['hidden'];
      $proposal     = $fetch['proposal'];
      
      $cat_name = $this->get_cat_name($cat_id);
      
      $css = ($css === $color1) ? $color2 : $color1;
      
      // $size = getimagesize('./proposal.gif');
      $proposal_img = '<img src="./proposal.gif" width="'. $size[0] .'" height="'. $size[1] .'" title="Empfehlung" alt="Empfehlung eines Besuchers" />';
      
      $clicks = $this->get_clicks($id);
      $website_img = $this->select_website_img($clicks);
      
      
      if(!empty($arr_id)
          && empty($_POST['submit_store_link_x']))
      {
        $edit = in_array($id, $arr_id);
      }
      
      if($edit)
      {
        $selected = ($proposal === 'yes') ? NULL : 'selected="selected"';
        $_POST['cat'] = $cat_id; // is needed because of print_categories()
        
        echo '
        <tr>
          <td><input type="text" name="new_link_name[]" value="'. $name .'" maxlength="50" size="22" /></td>
          <td width="90">
            <input type="text" name="url[]" value="'. $url .'" maxlength="250" size="32" />
            
            <input type="text" name="description[]" value="'. $description .'" maxlength="250" size="32" />
          </td>
          <td>
          ';
          $this->print_categories(4);
          echo '
          </td>
          <td>'. $date .'</td>
          <td><select name="proposal[]" size="1">
              <option value="yes" '. $selected .'>Empfehlung</option>
              <option value="no" '. $selected .'>speichern</option>
              <option value="delete">lschen</option>
            </select></td>
          <td>&nbsp;</td>
          <td class="'. $border .' '. $center .' '. $css .'"><input type="checkbox" value="'. $id .'" name="link_id[]" checked="checked" /></td>
        </tr>
        '; 
      }
      else
      {      
        if(strlen($name) > 20)
        {
          $name = substr($name, 0, 20);
          $name .= '...';
        }        
  
        echo '
        <tr>
          <td width="170" class="'. $border .' '. $css .'">
            <img onmouseover="return escape(\''. htmlentities($description) .'\')" src="./info.gif" border="0" width="'. $info[0] .'" height="'. $info[1] .'" title="info" alt="info" /> '. $name .'
          </td>
          <td class="'. $border .' '. $css .'"><a href="'. $url .'" target="_blank"><img src="./'. $website_img .'" border="0" width="'. $website[0] .'" height="'. $website[1] .'" title="'. $url .'" alt="website" /></a></td>
          <td class="'. $border .' '. $center .' '. $css .'">'. $cat_name .'</td>
          <td class="'. $border .' '. $center .' '. $css .'">'. $date .'</td>
          <td class="'. $border .' '. $center .' '. $css .'">Speichern</td>          
          <td class="'. $border .' '. $center .' '. $css .'">
        ';
        if(isset($_POST['submit_make_editable_x']))
        {
          echo '-';
        }
        else
        {
          echo '
            <input type="checkbox" value="'. $id .'" name="link_id[]" />
          ';        
        }
        echo '
          </td>
          <td>&nbsp;</td>
        </tr>
        '; 
      }      
      
    } // end while

    echo '
      <tr>
        <td class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Kategorie</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Seit</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Status</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">
          <input type="image" title="bearbeiten" alt="bearbeiten" src="./edit.gif" name="submit_make_editable" value="'. $id .'" />
        </td>
        <td class="'. $border .' '. $center .' '. $color0 .'">
          <input type="image" title="speichern" alt="speichern" src="./save.gif" name="submit_store_link" value="'. $id .'" />
        </td>     
      </tr>    
    </table>
    </form>';
              
  } // end func  
  
  
  /**
  * this function writes proposals into database
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return void
  */  
  function store_proposal()
  {
    // test in index_proposal.php, if $_POST is set
    $arr_id             = $_POST['link_id'];
    $arr_new_link_name  = $_POST['new_link_name'];
    $arr_url            = $_POST['url'];
    $arr_cat            = $_POST['cat'];
    $arr_description    = $_POST['description'];
    $arr_proposal       = $_POST['proposal']; // yes or no
    
    
    if(!empty($arr_id))
    {
      $flag = 0;
      foreach($arr_id as $link_id)
      {
          switch($flag)
          {
            case 0:
              if(isset($_POST['new_link_name']))
              {            
                $flag         = 1;
                $name         = trim(current($arr_new_link_name));
                $url          = trim(current($arr_url));
                $cat          = trim(current($arr_cat));
                $description  = trim(current($arr_description));
                $proposal = current($arr_proposal);
              }
            break;
            default:
              if(isset($_POST['new_link_name']))
              {             
                $name         = trim(next($arr_new_link_name));
                $url          = trim(next($arr_url));
                $cat          = trim(next($arr_cat));
                $description  = trim(next($arr_description));
                $proposal = next($arr_proposal);
              }
          }
  
        if($proposal === 'delete')
        {
          $sql = "DELETE FROM {$this->table['links']} 
                  WHERE `id` = $link_id";
        }
        elseif(!empty($name))
        {  
          $sql0 = "SELECT `cat_id`
                   FROM {$this->table['links']} 
                   WHERE `id` = $link_id";
          $fetch = mysql_fetch_array(mysql_query($sql0, $this->db_connect));
          
          // change category
          if($fetch['cat_id'] !== $cat)
          {
            // change category also in table clicks
            $sql0 = "UPDATE {$this->table['clicks']}
                    SET `cat_id` = '$cat'
                    WHERE `link_id` = '$link_id'";
            mysql_query($sql0, $this->db_connect);                    
            
            $sql = "UPDATE {$this->table['links']} 
                    SET `cat_id` = '$cat' ,
                        `name` = '$name' ,
                        `url` = '$url' ,
                        `description` = '$description' ,
                        `proposal` = '$proposal'
                    WHERE `id` = $link_id";          
          }
          else
          {
            $sql = "UPDATE {$this->table['links']} 
                    SET `name` = '$name' ,
                        `url` = '$url' ,
                        `description` = '$description' ,
                        `proposal` = '$proposal'
                    WHERE `id` = $link_id";    
          }
        }
        else
        {
          $sql = "UPDATE {$this->table['links']} 
                  SET `proposal` = 'no'
                  WHERE `id` = $link_id";           
        }
                
        mysql_query($sql, $this->db_connect);
  
      }
    } 
  } // end func
    
    
  /**
  * this function prints last x proposals
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $limit_ show last $limit_ proposals
  * return void
  */  
  function print_last_proposals($limit_ = 50)
  {
    $bold       = 'bold';
    $border     = 'border00';
    $center     = 'center_ll';
    $color0     = 'color0';
    $color1     = 'color1';
    $color2     = 'color2';
    $path_info  = './../admin/linklist/info.gif';
    $info       = getimagesize($path_info);
    $website    = getimagesize('./../admin/linklist/website.gif');       
      
    $sql = "SELECT `id`, `cat_id`, `name`, `url`, `description`, `date`, `hidden`, `proposal`
            FROM {$this->table['links']}
            WHERE `proposal` = 'yes'
            ORDER BY `date` ASC
            LIMIT $limit_";
    $query = mysql_query($sql, $this->db_connect);
    $count_links = mysql_num_rows($query);
    
    echo '
    <table class="linklist">
      <tr>
        <td colspan="2" class="'. $bold .' '. $border .' '. $center .' '. $color0 .'">Warteliste: '. $count_links .'</td>
        <td></td>
      </tr>      
      <tr>
        <td width="170" class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td width="90" class="'. $border .' '. $center .' '. $color0 .'">URL</td>
      </tr>
    ';
    
    
            
    while($fetch = mysql_fetch_array($query))
    {
      $id           = $fetch['id'];
      $cat_id       = $fetch['cat_id'];
      $name         = $fetch['name'];
      $url          = $fetch['url'];
      $description  = $fetch['description'];

      $website_img = $this->select_website_img($this->get_clicks($id));
      
      $css = ($css === $color1) ? $color2 : $color1;    
    
      if(strlen($name) > 20)
      {
        $name = substr($name, 0, 20);
        $name .= '...';
      }        


      echo '
      <tr>
        <td width="170" class="'. $border .' '. $css .'">
          <img onmouseover="return escape(\''. htmlentities($description) .'\')" src="'. $path_info .'" border="0" width="'. $info[0] .'" height="'. $info[1] .'" title="info" alt="info" /> '. $name .'
        </td>
        <td class="'. $border .' '. $css .'"><a href="./../admin/linklist/clicks.php?id='. $id .'&cat='. $cat_id .'&url='. rawurlencode($url) .'" target="_blank"><img src="./../admin/linklist/'. $website_img .'" border="0" width="'. $website[0] .'" height="'. $website[1] .'" title="'. $url .'" alt="website" /></a></td>
      </tr>
      ';       
    }
    
    echo '
      <tr>
        <td class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">URL</td>    
      </tr>    
    </table>
    ';    
  } // end func    


  /**
  * this function prints the latest URLs on screen
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $limit_ [optional]
  * return void
  */
  function latest_links($limit_ = 5)
  {
    $bold       = 'bold';
    $border     = 'border00';
    $center     = 'center_ll';
    $color0     = 'color0';
    $color1     = 'color1';
    $color2     = 'color2';
    $path_info  = './../admin/linklist/info.gif';
    $info       = getimagesize($path_info);
    $website    = getimagesize('./../admin/linklist/website.gif');   


    $sql = "SELECT t2.id AS id, t2.cat_id AS cat_id, t2.name AS name, t2.url AS url, t2.description AS description, t2.date AS date, t2.hidden AS hidden, t2.proposal AS proposal,
                   t3.id AS id2, t3.hidden AS hidden2
             FROM {$this->table['links']} t2
             LEFT JOIN {$this->table['cat']} t3
             ON t2.cat_id = t3.id
             WHERE t2.hidden = 'no'
               AND t2.proposal = 'no'
               AND t3.hidden = 'no'
             ORDER BY t2.date DESC
             LIMIT $limit_";

    $query = mysql_query($sql, $this->db_connect);
    $count_links = mysql_num_rows($query);
    
    echo '
    <table class="linklist">
      <tr>
        <td colspan="3" class="'. $bold .' '. $border .' '. $center .' '. $color0 .'">Die '. $count_links .' neuesten URLs</td>
        <td></td>
      </tr>      
      <tr>
        <td width="170" class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td width="90" class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td width="60" class="'. $border .' '. $center .' '. $color0 .'">Klicks</td>
      </tr>
    ';    
    
    while($fetch = mysql_fetch_array($query))
    {    
      $id          = $fetch['id'];
      $cat_id      = $fetch['cat_id'];
      $name        = $fetch['name'];
      $url         = $fetch['url'];
      $description = $fetch['description'];
      
      $clicks      = $this->get_clicks($id);
      $clicks      = ($clicks === NULL) ? 0 : $clicks;

      $website_img = $this->select_website_img($clicks);
      
      $css = ($css === $color1) ? $color2 : $color1;    
    
      if(strlen($name) > 20)
      {
        $name = substr($name, 0, 20);
        $name .= '...';
      }        

      echo '
      <tr>
        <td width="170" class="'. $border .' '. $css .'">
          <img onmouseover="return escape(\''. htmlentities($description) .'\')" src="'. $path_info .'" border="0" width="'. $info[0] .'" height="'. $info[1] .'" title="info" alt="info" /> '. $name .'
        </td>
        <td class="'. $border .' '. $css .'">
          <a href="./../admin/linklist/clicks.php?id='. $id .'&cat='. $cat_id .'&url='. rawurlencode($url) .'" target="_blank">
            <img src="./../admin/linklist/'. $website_img .'" border="0" width="'. $website[0] .'" height="'. $website[1] .'" title="'. $url .'" alt="website" />
          </a>
        </td>
        <td class="'. $border .' '. $center .' '. $css .'">'. $clicks .'</td>
      </tr>
      ';       
    }
    
    echo '
      <tr>
        <td class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Klicks</td>    
      </tr>    
    </table>
    ';
  } // end func 
  

  /**
  * this function counts all urls. not proposals
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $mode_ 1 is amdin mode - shows also hidden urls
  * return int
  */
  function count_all($mode_ = 0)
  {
    switch($mode_)
    {
      case 1:
        $sql = "SELECT COUNT(*) AS amount 
                FROM {$this->table['links']}
                WHERE `proposal` = 'no'";
      break;
      default:
        $sql = "SELECT COUNT(*) AS amount 
                FROM {$this->table['links']}
                WHERE `proposal` = 'no'
                  AND `hidden` = 'no'";    
    }
    $fetch = mysql_fetch_array(mysql_query($sql, $this->db_connect));
    $amount = (int)$fetch['amount'];  
  

    return $amount;
  } // end func


  /**
  * this function counts proposals
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * return int
  */
  function count_proposals()
  {
    $sql = "SELECT COUNT(*) AS amount
            FROM {$this->table['links']}
            WHERE `proposal` = 'yes'";      
    $fetch = mysql_fetch_array(mysql_query($sql, $this->db_connect));
    $amount = (int)$fetch['amount']; 


    return $amount;
  } // end func 

  /**
  * this function prints statistics in index_stats.php
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $mode_ 1 is amdin mode
  * return void
  */
  function show_stats($mode_ = 0)
  {
    echo '
    <table>
      <tr>
        <td width="150">Insgesamt:</td>
        <td>'. $this->count_all(1) .'</td>
      </tr>
      <tr>
        <td width="150">Versteckte:</td>
        <td>'. ($this->count_all(1)-$this->count_all()) .'</td>
      </tr>
      <tr>
        <td width="150">Empfehlungen:</td>
        <td>'. $this->count_proposals() .'</td>
      </tr>           
    ';

    echo '
    </table>
    <hr />
    ';
    $this->latest_visits(5, 1);
  } // end func
  
  
  /**
  * this function gets last visited sites
  * @author David Toniolo <d.toniolo@mtwebdesign.de>
  * @param int $limit_ [optional]
  * @param int $mode_ 1 [optional] is admin panel - because of path of images
  * return void
  */
  function latest_visits($limit_ = 5, $mode_ = 0)
  {
    $bold       = 'bold';
    $border     = 'border00';
    $center     = 'center_ll';
    $color0     = 'color0';
    $color1     = 'color1';
    $color2     = 'color2';
    $path_info  = './info.gif';
    $path       = NULL;

    if($mode_ === 0)
    {
      $path_info = '../admin/linklist/' . $path_info;
      $path = '../admin/linklist/';      
    }
    $info       = getimagesize($path_info);
    $website    = getimagesize("./{$path}website.gif");
    
      
    $sql = "SELECT t2.id, t2.cat_id, t2.name, t2.url, t2.description, t2.date, t2.hidden, t2.proposal,
                   t1.link_id, t1.clicks, t1.last_upd
            FROM {$this->table['links']} t2
            LEFT JOIN {$this->table['clicks']} t1
            ON t2.id = t1.link_id
            ORDER BY t1.last_upd DESC
            LIMIT $limit_";

    $query = mysql_query($sql, $this->db_connect);
    $count_links = mysql_num_rows($query);

    echo '
    <table class="linklist">
      <tr>
        <td colspan="3" class="'. $bold .' '. $border .' '. $center .' '. $color0 .'">Die '. $count_links .' zuletzt besuchten Seiten</td>
        <td></td>
      </tr>      
      <tr>
        <td width="170" class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td width="90" class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td width="60" class="'. $border .' '. $center .' '. $color0 .'">Klicks</td>
      </tr>
    ';    
    
    while($fetch = mysql_fetch_array($query))
    {    
      $id          = $fetch['id'];
      $cat_id      = $fetch['cat_id'];
      $name        = $fetch['name'];
      $url         = $fetch['url'];
      $description = $fetch['description'];
      
      $clicks      = $this->get_clicks($id);
      $clicks      = ($clicks === NULL) ? 0 : $clicks;

      $website_img = $this->select_website_img($clicks);
      
      $css = ($css === $color1) ? $color2 : $color1;    
    
      if(strlen($name) > 20)
      {
        $name = substr($name, 0, 20);
        $name .= '...';
      }        

      echo '
      <tr>
        <td width="170" class="'. $border .' '. $css .'">
          <img onmouseover="return escape(\''. htmlentities($description) .'\')" src="'. $path_info .'" border="0" width="'. $info[0] .'" height="'. $info[1] .'" title="info" alt="info" /> '. $name .'
        </td>
        <td class="'. $border .' '. $css .'"><a href="./../admin/linklist/clicks.php?id='. $id .'&cat='. $cat_id .'&url='. rawurlencode($url) .'" target="_blank"><img src="./'. $path . $website_img .'" border="0" width="'. $website[0] .'" height="'. $website[1] .'" title="'. $url .'" alt="website" /></a></td>
        <td class="'. $border .' '. $center .' '. $css .'">'. $clicks .'</td>
      </tr>
      ';       
    }
    
    echo '
      <tr>
        <td class="'. $border .' '. $center .' '. $color0 .'">Name</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">URL</td>
        <td class="'. $border .' '. $center .' '. $color0 .'">Klicks</td>
      </tr>    
    </table>
    ';

  } // end func           
} // end cls

?>
